#!/usr/bin/env python2.3
# -*- mode: python; coding: koi8-r; -*-
# (c) Con Radchenko mailto:lankier@gmail.com
#
# $Id: a-yoficator.py,v 1.3 2005/06/04 17:43:45 con Exp con $
#

import sys, os
import re, locale
from popen2 import popen2

#    ispell
ispell_cmd = 'ispell -a -m -d russian'
# 
encoding = locale.getpreferredencoding()


yo = unicode('', 'koi8-r').encode(encoding)
YO = unicode('', 'koi8-r').encode(encoding)
ye = unicode('', 'koi8-r').encode(encoding)
YE = unicode('', 'koi8-r').encode(encoding)
alpha = unicode('[ţ]+', 'koi8-r').encode(encoding)


ispell_out, ispell_in = None, None


def repl(mo):
    word = mo.group()

    ispell_in.write(word+'\n')
    ispell_in.flush()
    while True:
        ispell_ret = ispell_out.readline()
        if ispell_ret[0] in '&?#+-*':
            break

    if ispell_ret[0] == '&':
        i = ispell_ret.find(':')
        words = ispell_ret[i+1:].split(',')
        for w in words:
            w = w.strip()
            if w.replace(yo, ye) == word or w.replace(YO, YE) == word:
                return w

    return word


def main():

    if not 2 <= len(sys.argv) <= 3:
        sys.exit('usage: %s infile [outfile]' % sys.argv[0])

    if len(sys.argv) == 3:
        out_file = open(sys.argv[2], 'w')
    else:
        out_file = sys.stdout

    pat = re.compile(alpha)
    global ispell_out, ispell_in
    ispell_out, ispell_in = popen2(ispell_cmd)

    try:
        for s in open(sys.argv[1]):
            s = pat.sub(repl, s)
            out_file.write(s)
    finally:
        ispell_in.close()
        os.wait()


if __name__ == '__main__':
    main()



