#!/usr/bin/env python2.3
# -*- mode: python; coding: koi8-r; -*-
# (c) Con Radchenko mailto:lankier@gmail.com
#
# $Id: i-yoficator.py,v 1.3 2005/06/04 17:37:27 con Exp con $
#
import sys, os
import locale
from popen2 import popen2
import curses


#    ispell
ispell_cmd = 'ispell -a -m -d russian'
# 
encoding = locale.getpreferredencoding()


yo = unicode('', 'koi8-r').encode(encoding)
YO = unicode('', 'koi8-r').encode(encoding)
ye = unicode('', 'koi8-r').encode(encoding)
YE = unicode('', 'koi8-r').encode(encoding)
alpha = unicode('ţ', 'koi8-r').encode(encoding)

ispell_out, ispell_in = None, None

def repl_ye(s):
    i = 0
    while True:
        i=s.find('', i)
        if i < 0: break
        yield '%s%s' % (s[:i], s[i+1:])
        i += 1

def context():
    SCR_COLS = curses.COLS
    SCR_LINES = curses.LINES

    def split_line(l):
        lst = []
        i = 0
        while True:
            lst.append(l[i*SCR_COLS:(i+1)*SCR_COLS])
            i += 1
            if i*SCR_COLS >= len(l):
                break
        return lst

    start = max(0, line-SCR_LINES/2)
    l = lines[line][:column]
    lst = split_line(l)
    lst.reverse()
    before = lst

    for l in lines[line-1:start:-1]:

        lst = split_line(l)
        lst.reverse()
        before.extend(lst)
        if len(before) >= SCR_LINES/2:
            break

    before = before[:SCR_LINES/2]
    before.reverse()

    return ''.join(before)


def ask(word_from, word_to):

    stdscr.clear()

    stdscr.addstr(context())

    stdscr.addstr(word_from, curses.A_REVERSE)

    try:
        stdscr.addstr(lines[line][column+len(word_from):])
    except:
        pass
    else:
        for l in lines[line+1:]:
            try:
                stdscr.addstr(l)
            except:
                break

    stdscr.move(curses.LINES-1, 0)
    stdscr.clrtoeol()
    stdscr.addstr('replace %s to %s? [y/N/q]' % (word_from, word_to),
                  curses.A_REVERSE)

    #stdscr.refresh()
    #curses.flushinp()

    # clear input buffer
    stdscr.nodelay(1)
    stdscr.getstr()
    stdscr.nodelay(0)

    ch = stdscr.getch()

    return ch


def repl(word):
    ispell_in.write(word+'\n')
    ispell_in.flush()
    while True:
        ispell_ret = ispell_out.readline()
        if ispell_ret[0] in '&?#+-*':
            break

    if ispell_ret[0] in '*+':
        for w in repl_ye(word):
            ispell_in.write(w+'\n')
            ispell_in.flush()
            while True:
                ispell_ret = ispell_out.readline()
                if ispell_ret[0] in '&?#+-*':
                    break
            if ispell_ret[0] in '*+':
                ans = ask(word, w)
                if 0<ans<256:
                    ans = chr(ans)
                    if ans in 'yY':
                        return w
                    elif ans in 'qQ':
                        raise SystemExit

    return word


def main():

    if len(sys.argv) != 3:
        sys.exit('usage: %s infile outfile' % sys.argv[0])

    global ispell_out, ispell_in
    ispell_out, ispell_in = popen2(ispell_cmd)

    global stdscr
    stdscr = curses.initscr()
    curses.noecho()

    global lines, line, column
    lines = open(sys.argv[1]).readlines()
    line = 0

    out = []
    try:
        for s in lines:

            word = ''
            res = ''
            cursor = 0
            for c in s:
                if c in alpha:
                    word += c
                else:
                    if word:
                        column = cursor-len(word)
                        w = repl(word)
                        res += w+c
                        word = ''
                    else:
                        res += c
                cursor += 1
            out.append(res)

            line += 1

    finally:
        ispell_in.close()
        os.wait()
        curses.endwin()
        open(sys.argv[2], 'w').write(''.join(out))


if __name__ == '__main__':
    main()



